/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of FastAlternatives.xs. Do not edit this file, edit FastAlternatives.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "FastAlternatives.xs"
/* -*- c -*- */

#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* Support older versions of perl. */
#ifndef Newxz
#define Newxz(ptr, n, type) Newz(704, ptr, n, type)
#endif

struct trie {
    U16 bits;
    U16 has_unicode;
};

typedef struct trie *Text__Match__FastAlternatives;

struct pool {
    void *buf;
    void *curr;
};

static struct pool pool_create(size_t n) {
    struct pool pool;
    Newxz(pool.buf, n, char);
    pool.curr = pool.buf;
    return pool;
}

static void *pool_alloc(struct pool *pool, size_t n) {
    unsigned char *region = pool->curr;
    /* Ensure every allocation is on an even boundary, thus freeing up the
     * low-order bit of a pseudo-pointer for other purposes, even when each
     * pseudo-pointer is only 8 bits */
    if ((n & 1u))
        n++;
    pool->curr = region + n;
    return region;
}

static size_t pool_offset(const struct pool *pool, void *obj) {
    return ((U8 *)obj) - ((U8 *)pool->buf);
}

static int
array_has_unicode(pTHX_ AV *keywords) {
    I32 i, n = av_len(keywords);
    for (i = 0;  i <= n;  i++) {
        SV *sv = *av_fetch(keywords, i, 0);
        STRLEN len;
        char *s = SvPV(sv, len);
        const U8 *p = (const U8 *) s, *end = p + len;
        while (p < end)
            if (*p++ & 0x80u)
                return 1;
    }
    return 0;
}

#if PTRSIZE >= 8
#define BITS 64
#include "trie.c"
#endif

#define BITS 32
#include "trie.c"

#define BITS 16
#include "trie.c"

#define BITS 8
#include "trie.c"

#define NM_(x, y) x ## _ ## y
#define NM(name, bits) NM_(name, bits)
#if PTRSIZE >= 8
#define CALL(trie, name, arglist) \
    ( ((trie)->bits ==  8 ? (NM(name,  8)arglist) \
    : ((trie)->bits == 16 ? (NM(name, 16)arglist) \
    : ((trie)->bits == 32 ? (NM(name, 32)arglist) \
    :                       (NM(name, 64)arglist)))))
#else
#define CALL(trie, name, arglist) \
    ( ((trie)->bits ==  8 ? (NM(name,  8)arglist) \
    : ((trie)->bits == 16 ? (NM(name, 16)arglist) \
    :                       (NM(name, 32)arglist))))
#endif

static int utf8_valid(const U8 *s, STRLEN len) {
    static const U8 width[] = { /* start at 0xC2 */
        2,2,2,2,2,2,2,2,2,2,2,2,2,2,     /* 0xC2 .. 0xCF; two bytes */
        2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2, /* 0xD0 .. 0xDF; two bytes */
        3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3, /* 0xE0 .. 0xEF; three bytes */
        4,4,4,4,4,0,0,0,0,0,0,0,0,0,0,0, /* 0xF0 .. 0xF4; four bytes */
    };
    static const U8 mask[] = {  /* data bitmask for leading byte of N-byte unit */
        0u, 0u, 0x1Fu, 0x0Fu, 7u,
    };
    static const U32 min[] = {  /* lowest permissible value for an N-byte unit */
        0u, 0u, 0x80u, 0x800u, 0x10000u,
    };
    const U8 *p = s, *end = s + len;
    while (p < end) {
        if (*p < 0x80u)
            p++;                /* plain ASCII */
        else if (*p < 0xC2u)
            return 0;           /* 0x80 .. 0xC1 are impossible leading bytes */
        else {
            U8 w = width[*p - 0xC2u], i;
            U32 c;
            if (w == 0)
                return 0;       /* invalid leading byte */
            else if (end - p < w)
                return 0;       /* string too short for continuation bytes */
            c = *p & mask[w];
            for (i = 1;  i < w;  i++)
                if ((p[i] & 0xC0u) != 0x80u)
                    return 0;   /* continuation byte not in range */
                else
                    c = (c << 6u) | (p[i] & 0x3Fu);
            if (c < min[w])
                return 0;       /* sequence overlong */
            if (c >= 0xD800u && c < 0xE000u)
                return 0;       /* UTF-16 surrogate */
            p += w;
        }
    }

    return 1;
}

static int get_byte_offset(pTHX_ SV *sv, int pos) {
    STRLEN len;
    const unsigned char *s, *p;
    if (!SvUTF8(sv))
        return pos;
    s = (const unsigned char *) SvPV(sv, len);
    for (p = s;  pos > 0;  pos--) {
        /* Skip the sole byte (ASCII char) or leading byte (top >=2 bits set) */
        p++;
        /* Skip any continuation bytes (top bit set but not next bit) */
        while ((*p & 0xC0u) == 0x80u)
            p++;
    }
    return p - s;
}

/* If the trie used Unicode, make sure that the target string uses the same
 * encoding.  But if the trie didn't use Unicode, it doesn't matter what
 * encoding the target uses for any supra-ASCII characters it contains,
 * because they'll never be found in the trie.
 *
 * A pleasing performance enhancement would be as follows: delay upgrading a
 * byte-encoded SV until such time as we're actually looking at a
 * supra-ASCII character; then upgrade the SV, and start again from the
 * current offset in the string.  (Since by definition there are't any
 * supra-ASCII characters before the current offset, it's guaranteed to be
 * safe to use the old characters==bytes-style offset as a byte-oriented one
 * for the upgraded SV.)  It seems a little tricky to arrange that sort of
 * switcheroo, though; the inner loop is in a function that knows nothing of
 * SVs or encodings. */
#define GET_TARGET(trie, sv, len) \
    ((unsigned char *) (trie->has_unicode ? SvPVutf8(sv, len) : SvPV(sv, len)))

#line 178 "FastAlternatives.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 322 "FastAlternatives.c"

XS_EUPXS(XS_Text__Match__FastAlternatives_new_instance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_new_instance)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, keywords");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	AV *	keywords;
#line 177 "FastAlternatives.xs"
        struct trie *trie;
        HV *limits;
        HE *he;
        STRLEN maxlen = 0;
        I32 i, n, nodes;
        size_t dyn_ptrs = 0, odd_arrays = 0;
#line 341 "FastAlternatives.c"
	Text__Match__FastAlternatives	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    keywords = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not an ARRAY reference",
				"Text::Match::FastAlternatives::new_instance",
				"keywords");
		}
	} STMT_END
;
#line 184 "FastAlternatives.xs"
        /* Ensure all the arguments are acceptable */
        n = av_len(keywords);
        for (i = 0;  i <= n;  i++) {
            SV **sv = av_fetch(keywords, i, 0);
            char *s;
            STRLEN len;
            if (!sv || !SvOK(*sv))
                croak("Undefined element in %s->new", package);
            s = SvPVutf8(*sv, len);
            if (!utf8_valid((const U8 *) s, len))
                croak("Malformed or non-Unicode UTF-8 in %s->new", package);
            if (len > maxlen)
                maxlen = len;
        }

        /* For each possibly-improper prefix of each keyword, find the
         * minimum and maximum byte values for edges onwards from the node
         * which will represent that prefix.  The minimum and maximum are
         * encoded in a UV (min as the lowest-order byte, max as the next
         * byte up) and stored in a hash with the prefix as the key. */
        limits = newHV();
        for (i = 0;  i <= n;  i++) {
            STRLEN pos, len;
            SV *sv = *av_fetch(keywords, i, 0);
            char *s = SvPVutf8(sv, len);
            for (pos = 0;  pos <= len;  pos++) {
                U8 c = ((U8 *) s)[pos];
                SV *entry = *hv_fetch(limits, s, pos, 1);
                if (!SvIOK(entry)) /* sv_setuv() might give you an IOK-but-not-UOK sv */
                    sv_setuv(entry, (c << 8u) | c);
                else {
                    UV lim = SvUV(entry);
                    UV min = lim & 0xFFu, max = (lim & 0xFF00u) >> 8u;
                    if (c < min)
                        min = c;
                    else if (c > max)
                        max = c;
                    else        /* no change; don't bother doing sv_setuv() */
                        continue;
                    sv_setuv(entry, (max << 8u) | min);
                }
            }
        }

        /* Count nodes and dynamically-allocated pointers in limits */
        nodes = hv_iterinit(limits);
        while ((he = hv_iternext(limits))) {
            UV lim = SvUV(HeVAL(he));
            UV min = lim & 0xFFu, max = (lim & 0xFF00u) >> 8u;
            UV n = max - min;
            dyn_ptrs += n;
            /* For the 8-bit implementation, we'll need to allocate an extra
             * byte for every node that would otherwise be an odd number of
             * bytes long */
            if ((n & 1u))
                odd_arrays++;
        }

        /* Ensure we get a root node, even if there are no keywords */
        if (nodes == 0) {
            nodes++;
            hv_store(limits, "", 0, newSVuv(0u), 0);
        }

        /* Create the trie */
        if      (trie_data_fits_8( nodes, dyn_ptrs, odd_arrays))
            trie = trie_create_8( aTHX_ keywords, limits, maxlen, nodes, dyn_ptrs, odd_arrays);
        else if (trie_data_fits_16(nodes, dyn_ptrs, odd_arrays))
            trie = trie_create_16(aTHX_ keywords, limits, maxlen, nodes, dyn_ptrs, odd_arrays);
        else if (trie_data_fits_32(nodes, dyn_ptrs, odd_arrays))
            trie = trie_create_32(aTHX_ keywords, limits, maxlen, nodes, dyn_ptrs, odd_arrays);
#if PTRSIZE >= 8
        else if (trie_data_fits_64(nodes, dyn_ptrs, odd_arrays))
            trie = trie_create_64(aTHX_ keywords, limits, maxlen, nodes, dyn_ptrs, odd_arrays);
#endif

        SvREFCNT_dec(limits);

        if (!trie)
            croak("Sorry, too much data for %s", package);

        RETVAL = trie;
#line 440 "FastAlternatives.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Text::Match::FastAlternatives", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Match__FastAlternatives_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "trie");
    {
	Text__Match__FastAlternatives	trie;
#line 273 "FastAlternatives.xs"
        void *buf;
#line 462 "FastAlternatives.c"

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Text::Match::FastAlternatives::DESTROY",
			"trie")
;
#line 275 "FastAlternatives.xs"
        buf = trie;
        Safefree(buf);
#line 476 "FastAlternatives.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Text__Match__FastAlternatives_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_match)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trie, targetsv");
    {
	Text__Match__FastAlternatives	trie;
	SV *	targetsv = ST(1)
;
#line 283 "FastAlternatives.xs"
        STRLEN target_len;
        const unsigned char *target;
#line 495 "FastAlternatives.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::Match::FastAlternatives")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Text::Match::FastAlternatives::match",
			"trie", "Text::Match::FastAlternatives")
;
#line 286 "FastAlternatives.xs"
        SvGETMAGIC(targetsv);
        if (!SvOK(targetsv))
            croak("Target is not a defined scalar");
#line 512 "FastAlternatives.c"
#line 290 "FastAlternatives.xs"
        target = GET_TARGET(trie, targetsv, target_len);
        if (CALL(trie, trie_match,(trie, target, target_len)))
            XSRETURN_YES;
        XSRETURN_NO;
#line 518 "FastAlternatives.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Match__FastAlternatives_match_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_match_at)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "trie, targetsv, pos");
    {
	Text__Match__FastAlternatives	trie;
	SV *	targetsv = ST(1)
;
	int	pos = (int)SvIV(ST(2))
;
#line 301 "FastAlternatives.xs"
        STRLEN target_len;
        const unsigned char *target;
#line 539 "FastAlternatives.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::Match::FastAlternatives")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Text::Match::FastAlternatives::match_at",
			"trie", "Text::Match::FastAlternatives")
;
#line 304 "FastAlternatives.xs"
        SvGETMAGIC(targetsv);
        if (!SvOK(targetsv))
            croak("Target is not a defined scalar");
#line 556 "FastAlternatives.c"
#line 308 "FastAlternatives.xs"
        target = GET_TARGET(trie, targetsv, target_len);
        pos = get_byte_offset(aTHX_ targetsv, pos);
        if (pos <= (int) target_len) {
            target_len -= pos;
            target += pos;
            if (CALL(trie, trie_match_anchored,(trie, target, target_len)))
                XSRETURN_YES;
        }
        XSRETURN_NO;
#line 567 "FastAlternatives.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Match__FastAlternatives_exact_match); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_exact_match)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "trie, targetsv");
    {
	Text__Match__FastAlternatives	trie;
	SV *	targetsv = ST(1)
;
#line 323 "FastAlternatives.xs"
        STRLEN target_len;
        const unsigned char *target;
#line 586 "FastAlternatives.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::Match::FastAlternatives")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Text::Match::FastAlternatives::exact_match",
			"trie", "Text::Match::FastAlternatives")
;
#line 326 "FastAlternatives.xs"
        SvGETMAGIC(targetsv);
        if (!SvOK(targetsv))
            croak("Target is not a defined scalar");
#line 603 "FastAlternatives.c"
#line 330 "FastAlternatives.xs"
        target = GET_TARGET(trie, targetsv, target_len);
        if (CALL(trie, trie_match_exact,(trie, target, target_len)))
            XSRETURN_YES;
        XSRETURN_NO;
#line 609 "FastAlternatives.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Match__FastAlternatives_pointer_length); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_pointer_length)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "trie");
    {
	Text__Match__FastAlternatives	trie;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::Match::FastAlternatives")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Text::Match::FastAlternatives::pointer_length",
			"trie", "Text::Match::FastAlternatives")
;
#line 339 "FastAlternatives.xs"
        /* This is not part of the public API; it merely exposes an
         * implementation detail for testing */
        RETVAL = trie->bits;
#line 639 "FastAlternatives.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Text__Match__FastAlternatives_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_dump)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "trie");
    {
	Text__Match__FastAlternatives	trie;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Text::Match::FastAlternatives")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    trie = INT2PTR(Text__Match__FastAlternatives,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Text::Match::FastAlternatives::dump",
			"trie", "Text::Match::FastAlternatives")
;
#line 349 "FastAlternatives.xs"
        CALL(trie, trie_dump,("", 0, trie, 0));
#line 666 "FastAlternatives.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Text__Match__FastAlternatives_utf8_valid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Text__Match__FastAlternatives_utf8_valid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, sv");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	SV *	sv = ST(1)
;
#line 356 "FastAlternatives.xs"
        STRLEN len;
        char *s;
#line 686 "FastAlternatives.c"
	int	RETVAL;
	dXSTARG;
#line 359 "FastAlternatives.xs"
        /* This is not part of the public API; it merely exposes an
         * implementation detail for testing */
        s = SvPV(sv, len);
        RETVAL = utf8_valid(s, len);
#line 694 "FastAlternatives.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Text__Match__FastAlternatives); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Text__Match__FastAlternatives)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Text::Match::FastAlternatives::new_instance", XS_Text__Match__FastAlternatives_new_instance);
        newXS_deffile("Text::Match::FastAlternatives::DESTROY", XS_Text__Match__FastAlternatives_DESTROY);
        newXS_deffile("Text::Match::FastAlternatives::match", XS_Text__Match__FastAlternatives_match);
        newXS_deffile("Text::Match::FastAlternatives::match_at", XS_Text__Match__FastAlternatives_match_at);
        newXS_deffile("Text::Match::FastAlternatives::exact_match", XS_Text__Match__FastAlternatives_exact_match);
        newXS_deffile("Text::Match::FastAlternatives::pointer_length", XS_Text__Match__FastAlternatives_pointer_length);
        newXS_deffile("Text::Match::FastAlternatives::dump", XS_Text__Match__FastAlternatives_dump);
        newXS_deffile("Text::Match::FastAlternatives::utf8_valid", XS_Text__Match__FastAlternatives_utf8_valid);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

